VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   0  'Kein
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows-Standard
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Dieser Source stammt von http://www.vb-fun.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source !

Option Explicit

'=== DirectDraw-Initialisations-Variablen ===
Dim DX7 As New DirectX7
Dim DD7 As DirectDraw7
Dim SurfaceDesc As DDSURFACEDESC2
Dim PrimarySurface As DirectDrawSurface7
Dim BackBuffer As DirectDrawSurface7
Dim bmpAnimation1 As DirectDrawSurface7
Dim bmpAnimation2 As DirectDrawSurface7

Dim running As Boolean


Private Sub Form_Load()
  Dim Destrect As RECT
  Dim SrcRect As RECT
  Dim hlpY As Single
  
  Me.Show
  Me.Refresh
  
  Initialization   'DirectDraw initialisieren
  BitmapLaden      'Laden der Bitmaps
  
  running = True
    
  Do
    If GetTime - FrameTime < FrameRate Then
      DoEvents
    Else
      'ERSTE ANIMATION
      '===============
      'die Einzelbilder sind alle in einer Zeile,
      'daher braucht der AnimationsCounter nur mit der Breite
      'des Einzelbildes multipliziert werden
      
      'Festlegen welchen Bereich vom Bitmap wir kopieren
      'mchten ... in diesem Fall nur einen Teil
      With SrcRect
        .Left = (Animation1.Width * Animation1.AniCount): _
              .Right = (.Left + Animation1.Width)
        .Top = 0: .Bottom = Animation1.Height
      End With
      'Ausschnitte in den Backbuffer zeichnen
      BackBuffer.BltFast _
            100, 100, bmpAnimation1, SrcRect, DDBLTFAST_WAIT
      'AnimationCounter erhhen
      With Animation1
        .AniCount = .AniCount + 1
        If .AniCount > .AniMax Then .AniCount = 0
      End With
      
      'ZWEITE ANIMATION
      '===============
      'die Einzelbilder sind in 4 Zeile aufgeteilt
      'daher muss der AnimationsCounter auch mit der Hhe
      'des Einzelbildes multipliziert werden
      
      'Festlegen welchen Bereich vom Bitmap wir kopieren
      'mchten ... in diesem Fall nur einen Teil
      With SrcRect
        hlpY = Int(Animation2.AniCount / 11)
        .Left = (Animation2.AniCount - (hlpY * 11)) * _
            Animation2.Width: .Right = (.Left + Animation2.Width)
        .Top = (hlpY * Animation2.Height): _
            .Bottom = (.Top + Animation2.Height)
      End With
      'Ausschnitte in den Backbuffer zeichnen
      BackBuffer.BltFast _
            300, 100, bmpAnimation2, SrcRect, DDBLTFAST_WAIT
      'AnimationCounter erhhen
      With Animation2
        .AniCount = .AniCount + 1
        If .AniCount > .AniMax Then .AniCount = 0
      End With
      
      BackBuffer.SetForeColor vbRed
      BackBuffer.SetFont Me.Font
      BackBuffer.DrawText _
            10, 10, "DirectDraw und Bitmaps-Animation", False
      BackBuffer.DrawText _
            10, 30, "<Esc> beendet das Programm", False
      
      'Inhalt des BackBuffers in den PrimarySurface kopieren
      PrimarySurface.Flip Nothing, DDFLIP_WAIT
      FrameTime = GetTime
      
      'BackBuffer lschen
      'da ansonsten alter Speicherinhalt angezeigt wird
      ClearBuffer vbBlack
      
      DoEvents
    End If
  Loop While running
  
  Terminate
End Sub


Private Sub Form_KeyPress(KeyAscii As Integer)
  If (KeyAscii = vbKeyEscape) Then
    running = False
  End If
End Sub


Sub Initialization() 'DirectDraw wird initialisiert
    
  'Holen wir uns den Zugriff auf das DirectDraw-Objekt.
  'Der leere String-Parameter bedeutet,
  'dass der aktive Bildschirmtreiber benutzt werden soll
  Set DD7 = DX7.DirectDrawCreate("")
  'Die Anwendung soll im VollbildModus laufen
  DD7.SetCooperativeLevel Me.hWnd, DDSCL_EXCLUSIVE Or _
        DDSCL_FULLSCREEN Or DDSCL_ALLOWREBOOT
  'Auflsung und Farbtiefe deklarieren
  DD7.SetDisplayMode SCREENWIDTH, SCREENHEIGHT, 16, 0, _
        DDSDM_DEFAULT
  'Beschreibung des PrimarySurface mit einem BackBuffer
  With SurfaceDesc
    .lFlags = DDSD_CAPS Or DDSD_BACKBUFFERCOUNT
    .ddsCaps.lCaps = _
        DDSCAPS_PRIMARYSURFACE Or DDSCAPS_FLIP Or DDSCAPS_COMPLEX
    .lBackBufferCount = 1
  End With
  'PrimarySurface initialisieren auf dem alles abgebildet wird
  Set PrimarySurface = DD7.CreateSurface(SurfaceDesc)
  
  'Fr die Beschreibung des Backbuffers bentigen wir nur
  'den ddsCaps-Bereich
  SurfaceDesc.ddsCaps.lCaps = DDSCAPS_BACKBUFFER
  'BackBuffer initialisieren in dem alles gezeichnet und dann
  'in die PrimarySurface ge'flipt wird
  Set BackBuffer = _
        PrimarySurface.GetAttachedSurface(SurfaceDesc.ddsCaps)
End Sub


Sub BitmapLaden()
  Dim BmpDesc As DDSURFACEDESC2
      
  BmpDesc.lFlags = DDSD_CAPS Or DDSD_HEIGHT Or DDSD_WIDTH
  BmpDesc.ddsCaps.lCaps = DDSCAPS_OFFSCREENPLAIN
  
  'die Einzelbilder der Animation haben die gleiche Breite und Hhe
  Animation1.Width = 49: Animation1.Height = 104
  'die Animation beginnt beim ersten Bild und die Animation hat 32 Einzelbilder
  Animation1.AniCount = 0: Animation1.AniMax = 31
  'die gesamte Animation wird geladen
  BmpDesc.lWidth = 1568: BmpDesc.lHeight = 104
  
  Set bmpAnimation1 = DD7.CreateSurfaceFromFile _
        (App.Path & "\Animation1.bmp", BmpDesc)
  
  'die Einzelbilder der Animation haben die gleiche Breite und Hhe
  Animation2.Width = 35: Animation2.Height = 35
  'die Animation beginnt beim ersten Bild und die Animation hat 44 Einzelbilder
  Animation2.AniCount = 0: Animation2.AniMax = 43
  'die gesamte Animation wird geladen
  BmpDesc.lWidth = 385: BmpDesc.lHeight = 140
  
  Set bmpAnimation2 = DD7.CreateSurfaceFromFile _
        (App.Path & "\Animation2.bmp", BmpDesc)

End Sub


Sub Terminate()
  Set bmpAnimation1 = Nothing
  Set bmpAnimation2 = Nothing
  'alte Auflsung wiederherstellen
  DD7.RestoreDisplayMode
  DD7.SetCooperativeLevel Me.hWnd, DDSCL_NORMAL
  Set PrimarySurface = Nothing
  Set DD7 = Nothing
  Set DX7 = Nothing
  End
End Sub


Sub ClearBuffer(Color As Long)
  Dim Destrect As RECT
  
  With Destrect
    .Bottom = SCREENHEIGHT
    .Left = 0
    .Right = SCREENWIDTH
    .Top = 0
  End With
  BackBuffer.BltColorFill Destrect, Color
End Sub


Function GetTime() As Long
  GetTime = DX7.TickCount
End Function

